import { UrlObject } from "./configparser";
import async = require("async");
import { RequestCallback, Response } from "request";
export declare class ExecutionStrategy {
    static PARALLEL: typeof async.parallel;
    static SERIES: typeof async.series;
    static get(name: string): typeof async.parallel | null;
}
export declare type ErrorResponseObject = {
    error?: Error;
};
export declare type ResponseObject = {
    response: Response;
    body: string;
};
export declare type BodyReplacer = {
    searchValue: string;
    replacer: string;
};
export declare function setMultipleUrlExecutionStrategy(strategyString: string): boolean;
export declare function isHttpSuccessCode(statusCode: number): boolean;
export declare function isHttpRedirectCode(statusCode: number): boolean;
export declare function httpRequest(urlObject: UrlObject, callback: RequestCallback, ...bodyReplacer: BodyReplacer[]): void;
export declare function multipleHttpRequests(urlObjectArray: UrlObject[], callback: (result: (ErrorResponseObject | ResponseObject)[]) => void): void;
//# sourceMappingURL=http.d.ts.map