"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.enqueueNotificationRegistrationIfDefined = void 0;
function enqueueNotificationRegistrationIfDefined(api, log, notificationID, notificationPassword, handler) {
    if (notificationID) {
        api.on('didFinishLaunching', () => {
            // @ts-ignore
            const registration = global.notificationRegistration || api.notificationRegistration;
            if (registration && typeof registration === "function") {
                try {
                    registration(notificationID, handler, notificationPassword);
                    log("Detected running notification server. Registered successfully!");
                }
                catch (error) {
                    log("Could not register notification handler. ID '" + notificationID + "' is already taken!");
                }
            }
        });
    }
}
exports.enqueueNotificationRegistrationIfDefined = enqueueNotificationRegistrationIfDefined;
//# sourceMappingURL=notifications.js.map